package org.jcg.zheng;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class StringEqualsTest {
	private StringEqualsUtil strUtil = new StringEqualsUtil();

	private void compareString(String compareMethod) {
		String testString = "ABC";
		char[] firstChar = { 'A', 'a' };
		char[] secondChar = { 'B', 'b' };
		char[] thirdChar = { 'C', 'c' };

		for (char first : firstChar) {
			for (char second : secondChar) {
				for (char third : thirdChar) {
					char[] matchChars = { first, second, third };

					String matchString = String.valueOf(matchChars);

					switch (compareMethod) {
					case "equalsIgnoreCase":
						assertTrue(testString.equalsIgnoreCase(matchString));
						System.out.printf("'%s' equalsIgnoreCase '%s', ret = %b\n", testString, matchString,
								testString.equalsIgnoreCase(matchString));

						break;
					case "test_equals_string":
						System.out.printf("'%s' equals '%s', ret = %b\n", testString, matchString,
								testString.equals(matchString));

						break;
					case "test_equals_charArray":
						System.out.printf("'%s' equals '%s', ret = %b\n", testString, matchChars,
								testString.equals(matchChars));
						break;
					case "equalsIgnoreCase_via_uppercase":
						assertTrue(strUtil.equalsIgnoreCase_via_uppercase(testString, matchString));
						System.out.printf("'%s' equalsIgnoreCase_via_uppercase '%s', ret = %b\n", testString,
								matchString, strUtil.equalsIgnoreCase_via_uppercase(testString, matchString));
						break;

					case "equalsIgnoreCase_via_lowercase":
						assertTrue(strUtil.equalsIgnoreCase_via_lowercase(testString, matchString));
						System.out.printf("'%s' equalsIgnoreCase_via_lowercase '%s', ret = %b\n", testString,
								matchString, strUtil.equalsIgnoreCase_via_lowercase(testString, matchString));
						break;
					}
				}
			}
		}
	}

	@Test
	public void test_equals_charArray() {
		compareString("test_equals_charArray");
	}

	@Test
	public void test_equals_string() {
		compareString("test_equals_string");
	}

	@Test
	public void test_equalsIgnoreCase() {
		compareString("equalsIgnoreCase");
	}

	@Test
	public void test_equalsIgnoreCase_via_lowercase() {
		compareString("equalsIgnoreCase_via_lowercase");
	}

	@Test
	public void test_equalsIgnoreCase_via_uppercase() {
		compareString("equalsIgnoreCase_via_uppercase");
	}

	@Test
	public void test_null() {
		assertTrue(strUtil.equalsIgnoreCase_via_uppercase(null, null));
		assertFalse(strUtil.equalsIgnoreCase_via_uppercase(null, "NA"));
		assertFalse(strUtil.equalsIgnoreCase_via_uppercase("NA", null));

		assertTrue(strUtil.equalsIgnoreCase_via_lowercase(null, null));
		assertFalse(strUtil.equalsIgnoreCase_via_lowercase(null, "NA"));
		assertFalse(strUtil.equalsIgnoreCase_via_lowercase("NA", null));
	}

}
